#!/usr/bin/perl
# 'Brian' Theme - homefolder.pl
# Last Updated: 27/02/2004

# 			GNU General Public License
# This file is part of 'Brian' Theme.

# 'Brian' Theme is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# 'Brian' Theme is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with 'Brian' Theme; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

$count = 0;
$finished = 0;
$current_user = `whoami`;

chomp($current_user);

# First open password file.
open(PASSWD, "/etc/passwd");
flock(PASSWD, 2);
@passwd_file = <PASSWD>;
flock(PASSWD, 8);
close(PASSWD);

$passwd_filelength = @passwd_file;

do {
	# remove line returns from end of row
	chomp(@passwd_file[$count]);

	# split each row (account detail) by ':' seperator for each piece of info
	@passwd_row = split(/:/, @passwd_file[$count]);

	if ($current_user eq @passwd_row[0]) {
		# only perform disk usage checks on non root directory accounts
		if (@passwd_row[5] ne "/") {
			# only perform checks on those whos home dir's exist.
			if (-d @passwd_row[5]) {
				$currentUserHomedir = @passwd_row[5];
				
				# calculate disk usage for users home dir
				$system = `du -ksh $currentUserHomedir`;

				# get disk usage values
				($currentHomedirBytes) = split(/\t/, $system);

				if ($currentHomedirBytes =~ m/M/) {
					$currentHomedirBytes =~ s/M/" Mb"/eg;
				} elsif ($currentHomedirBytes =~ m/K/) {
					$currentHomedirBytes =~ s/K/" Kb"/eg;
				} elsif ($currentHomedirBytes =~ m/B/) {
					$currentHomedirBytes =~ s/B/" B"/eg;
				}
				
				# store homedir/disk usage values.
				$currentUserHomedirDU = $currentHomedirBytes;
			} else {
				# homedir not found
				$currentUserHomedir = "Not Found";
				$currentUserHomedirDU = "n/a";
			}
		}
	}
	
	if ($count eq "$passwd_filelength") {
		$finished = 1;
	}
	
	$count++;
} while ($finished == 0);

print "$currentUserHomedir\n$currentUserHomedirDU";

# Exit
exit;
